<?php

namespace FiloBlu\CronExtension\Shell;

use Magento\Framework\OsInfo;
use Magento\Framework\Shell\CommandRenderer;

/**
 * Class CommandRendererBackgroundWithPid
 * @package FiloBlu\Cron\Shell
 */
class CommandRendererBackgroundWithPid extends CommandRenderer
{
    /**
     * @var OsInfo
     */
    protected $osInfo;

    /**
     * @param OsInfo $osInfo
     */
    public function __construct(OsInfo $osInfo)
    {
        $this->osInfo = $osInfo;
    }

    /**
     * Render command with arguments
     *
     * @param string $command
     * @param array $arguments
     * @return string
     */
    public function render($command, array $arguments = [])
    {
        $command = parent::render($command, $arguments);

        return $this->osInfo->isWindows() ?
            'start /B "magento background task" ' . $command
            : str_replace('2>&1', '> /dev/null & echo $!', $command);
    }
}
