<?php

namespace FiloBlu\CronExtension\Shell;
/**
 * Class ProcessAwaiter
 * @package FiloBlu\Cron\Shell
 */
class ProcessAwaiter
{
    /**
     * @var bool
     */
    protected $initialized = false;
    /**
     * @var array
     */
    protected $processIds = [];

    /**
     * @param $pid
     */
    public function add($pid)
    {
        $this->init();
        $this->processIds[$pid] = true;
    }

    /**
     *
     */
    protected function init()
    {
        if ($this->initialized) {
            return;
        }

        register_shutdown_function([&$this, 'waitAllProcesses']);
    }

    /**
     *
     */
    public function waitAllProcesses()
    {
        $running = count($this->processIds);

        while ($running > 0) {
            foreach ($this->processIds as $pid => $status) {
                if ($status === false) {
                    continue;
                }

                $this->processIds[$pid] = $this->isRunning($pid);
            }

            $running = 0;

            foreach ($this->processIds as $pid => $status) {
                if ($status) {
                    $running++;
                }
            }

            usleep(250000);
        }
    }

    /**
     * @param $pid
     * @return bool
     */
    public function isRunning($pid)
    {
        $isRunning = false;
        if (strncasecmp(PHP_OS, 'win', 3) === 0) {
            $out = [];
            exec("TASKLIST /FO LIST /FI \"PID eq ${pid}\"", $out);
            if (count($out) > 1) {
                $isRunning = true;
            }
        } elseif (posix_kill((int)$pid, SIG_DFL)) {
            $isRunning = true;
        }
        return $isRunning;
    }
}